//*****************************************************************************************************
//  1. t@C
//		SchematicFrm.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		ڑn}E@\n}E@\}Flash\pt[EBhE
//----------------------------------------------------------------------------------------------------
//  3. l
//*****************************************************************************************************

#include "stdafx.h"
#include "Schematic.h"
#include "SchematicFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSchematicFrame

IMPLEMENT_DYNAMIC(CSchematicFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CSchematicFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

//*****************************************************************************************************
//  1. ֐
//		CSchematicFrame::CreateFrameWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t[EBhE쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nActionCode			[I] ANVR[h
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicFrame::CreateFrameWindow(int nActionCode)
{
	GetSchematicInfo();

	// fXNgbṽTCY擾
	CRect rect;
	::SystemParametersInfo(SPI_GETWORKAREA, 0, rect, 0);

	// fXNgbv10sNZ\
	rect.DeflateRect(10, 10);

	// t[EBhE쐬
	if (!Create(AfxRegisterWndClass(0, 0, 0, AfxGetApp()->LoadIcon(IDR_MAINFRAME)), m_sWindowTitle, WS_OVERLAPPEDWINDOW | WS_VISIBLE, rect, AfxGetMainWnd(), NULL, 0L))
		return;

	// CEBhẼ|C^ݒ
	if (AfxGetApp()->m_pMainWnd == NULL)
		AfxGetApp()->m_pMainWnd = this;

	m_pWndView->ShowSchematic(m_pMenuClass, m_sFlashFileName, nActionCode);
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicFrame::PreCreateWindow
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t[EBhE쐬O
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CREATESTRUCT&		cs			[I] EBhEp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	TRUE
//*****************************************************************************************************
BOOL CSchematicFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	// WS_EX_CLIENTEDGEX^C폜
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicFrame::OnCreate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t[EBhE쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCREATESTRUCT		lpCreateStruct			[I] EBhEp[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		int		0
//*****************************************************************************************************
int CSchematicFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// r[EBhE쐬
	m_pWndView = (CSchematicView *)m_pViewClass->CreateObject();
	if (!m_pWndView->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW | WS_CLIPCHILDREN, CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
		return -1;

	// Xe[^Xo[쐬
	if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT)))
		return -1;      // 쐬ł܂łB

	return 0;
}


// CSchematicFrame bZ[W nh

//*****************************************************************************************************
//  1. ֐
//		CSchematicFrame::OnDestroy
//----------------------------------------------------------------------------------------------------
//  2. @\
//		t[EBhEj
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicFrame::OnDestroy()
{
	CFrameWnd::OnDestroy();

	// CEBhEOʂɕ\
	AfxGetMainWnd()->SetForegroundWindow();
	AfxGetMainWnd()->UpdateWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicFrame::GetSchematicInfo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		}\EBhEf[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicFrame::GetSchematicInfo()
{
	SSchematicWindow *pSchematicWindow = m_lSchematicWindow.RemoveHead();

	// }\Xgf[^oϐɐݒ肷
	m_sWindowTitle = pSchematicWindow->sWindowTitle;
	m_sFlashFileName = pSchematicWindow->sFlashFileName;
	m_pMenuClass = pSchematicWindow->pMenuClass;
	m_pViewClass = pSchematicWindow->pViewClass;
}

//*****************************************************************************************************
//  1. ֐
//		CSchematicFrame::OnClose
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEN[Y
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CSchematicFrame::OnClose()
{
	if (m_lSchematicWindow.IsEmpty()) {
		// }\XgȂEBhE
		CFrameWnd::OnClose();
	} else {
		// }\XgłȂΎ̐}\\
		GetSchematicInfo();
		SetWindowText(m_sWindowTitle);
		m_pWndView->ShowSchematic(m_pMenuClass, m_sFlashFileName, 0);
	}
}
